
volatile UINT pion_tourne;		// Etat de rotation des pions dans le menu, 'volatile' car chang par le timer

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Reprogrammation des fonctions graphiques usuelles afin de fonctionner en niveaux de gris
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void draw_line(int x1, int y1, int x2, int y2)
{
	int i;
	for (i = 0; i<=1; i++)
	{
		SetPlane(i);
		DrawLine(x1, y1, x2, y2, 1);
	}
}

void draw_str(int x, int y, char *str)
{
	int i;
	for (i = 0; i<=1; i++)
	{
		SetPlane(i);
		DrawStr(x, y, str, 4);
	}
}

void draw_rect(int x1, int y1, int x2, int y2, int couleur)
{
	int i;
	for (i = 0; i<=1; i++)
	{
		SetPlane(i);
		DrawClipRect(MakeWinRect(x1, y1, x2, y2) , &(SCR_RECT){0, 0, 159, 99}, couleur);
	}
}

void fill_rect(int x1, int y1, int x2, int y2, int couleur)
{
	int i;
	SCR_RECT rect = {x1, y1, x2, y2};
	for (i = 0; i<=1; i++)
	{
		SetPlane(i);
		ScrRectFill(&rect, &(SCR_RECT){0, 0, 159, 99}, couleur);
	}
}

void draw_multi(int x, int y, MULTI_LINE *multi)
{
	int i;
	for (i = 0; i<=1; i++)
	{
		SetPlane(i);
		DrawMultiLines(x, y, multi);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Affiche le pion nnum  l'emplacement (x, y)
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void bitmap(int x, int y, int num)
{
	static int pion[] = {	7,7,14404,33410,33348,14336,		//dessin des pions
							7,7,14460,65278,65148,14336,
							7,7,   56,31998,31800,    0,
							7,7,    0,31998,31744,    0,
							7,7,    0,31874,31744,    0,
							7,7,   56,17538,17464,    0,
							7,7,14404,33410,33348,14336,
							7,7,   56,17538,17464,    0,
							7,7,    0,31874,31744,    0,
							7,7,    0,31998,31744,    0,
							7,7,   56,31998,31800,    0,
							7,7,    0,    0,    0,    0};
									
	BitmapPut(x, y, &pion[6*num], &(SCR_RECT){0, 0, 159, 99}, 4);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Affiche le pion ncouleur dans la case 'caze'
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void draw_pion(int caze, int couleur)
{
	bitmap(10*(caze%9)+6, 10*caze/9-10*caze%9+16, couleur);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Affiche des pions qui tournent (procdure appele par un timer)
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void tourne_pion(void)
{
	pion_tourne %= 10; pion_tourne++;
	SetPlane(0);
	bitmap(23, tourne_pion_y, pion_tourne);
	bitmap(128, tourne_pion_y, pion_tourne);
	SetPlane(1);
	bitmap(23, tourne_pion_y, pion_tourne);
	bitmap(128, tourne_pion_y, pion_tourne);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Dessine le curseur en invers dans la case 'caze'
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void draw_curseur(int caze)
{
	static MULTI_LINE curseur = {4, 2,0,0,8,0, 2,0,1,0,7, 2,8,1,8,7, 2,0,8,8,8};

	DrawMultiLines(10*(caze%9)+5, 10*caze/9-10*caze%9+15, &curseur);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Augmente brivement le contraste
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void contrast_plus(int n)
{
	int i, j;
	for (i=0; i<5; i++)
	{
		OSContrastDn();
		for (j=0; j<=n; j++);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Diminue brivement le contraste
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void contrast_moins(int n)
{
	int i, j;
	for (i=0; i<5; i++)
	{
		OSContrastUp();
		for (j=0; j<=n; j++);
	}
}
