
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Affiche un menu d'options, accessible  partir du menu principal
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void options(BYTE joueur_type[], char *niveau[])
{
	static MULTI_LINE place_coche = {4, 1,0,0,6,0, 1,6,0,6,6, 1,6,6,0,6, 1,0,6,0,0 };
	static MULTI_LINE coche = {3, 2,0,0,4,4, 2,0,4,1,3, 2,4,0,3,1};
	static MULTI_LINE lignes = {3, 1,fr_eng(68, 48),73,fr_eng(70, 50),73, 1,fr_eng(78, 48),81,fr_eng(80,50),81, 1,fr_eng(109, 48),89,fr_eng(111, 50),89};
	int touche, i = 0;

	tourne_pion_y = 33;
	fill_rect(21, 30, 136, 90, 0);
	DrawLine(23,55,134,55, 1);

	FontSetSys(PETIT);
	draw_str(35, 59, fr_eng("-/+ Rgler le contraste", "-/+ Set contrast"));

	draw_str(47, 67, fr_eng("Mode perdant active", "Looser mode on"));
	draw_multi(38, 66, &place_coche);
	if (perdant) draw_multi(39, 67, &coche);

	draw_str(47, 75, fr_eng("Afficher aides", "Tips on"));
	draw_multi(38, 74, &place_coche);
	if (tips) draw_multi(39, 75, &coche);

	draw_str(47, 83, fr_eng("Pions tournant en 3D", "3D rotating discs"));
	draw_multi(38, 82, &place_coche);
	if (faire_tourner) draw_multi(39, 83, &coche);

	draw_multi(0, 0, &lignes);

	FontSetSys(NORMAL);

	draw_str(35, 33, fr_eng("NOIRS:", "BLACKS:"));
	draw_str(35, 45, fr_eng("BLANCS:", "WHITES:"));
	contrast_moins(1000);

	OSVRegisterTimer(2, 3, tourne_pion);

	do
	{
		draw_str(80, 33, niveau[joueur_type[1]]);
		draw_str(80, 45, niveau[joueur_type[0]]);
		touche = ngetchx();
		if ((touche == HAUT)||(touche == BAS))
		{
			tourne_pion_y = 33+12*(i = (i+1)%2);
			fill_rect(23, 33, 32, 52, 0);
			fill_rect(126, 33, 134, 52, 0);
		}
		joueur_type[!i] = (joueur_type[!i]+(touche == DROITE)-(touche == GAUCHE)+8)%8;
		if (touche == fr_eng(P, L)) { perdant = !perdant; draw_multi(39, 67, &coche); }
		if (touche == fr_eng(A, T)) { tips = !tips; draw_multi(39, 75, &coche); }
		if (touche == S) { faire_tourner = !faire_tourner; draw_multi(39, 83, &coche); }
		if (touche == PLUS) OSContrastUp();
		if (touche == MOINS) OSContrastDn();
		if ((touche != ESCAPE)&&(touche != ENTER)) fill_rect(99, 33, 125, 52, 0);
	} while ((touche != ESCAPE)&&(touche != ENTER));

	OSVFreeTimer(2);
	contrast_plus(15000);
	tourne_pion_y = 57;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Affiche des infos sur Othello II
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void about()
{
	FontSetSys(PETIT);
	fill_rect(21, 30, 136, 90, 0);
	draw_str(22, 73, fr_eng("Compil avec Ti-GCC le 10/06/00", "Compiled with Ti-GCC   06-10-00"));
	draw_str(32, 81, fr_eng("Librairies par Zeljko Juric", "  Libraries by Zeljko Juric"));
	draw_str(27, 60, "francois.leiber@libertysurf.fr");
	DrawLine(28, 66, 129, 66, 1);
	FontSetSys(NORMAL);
	draw_str(45, 32, fr_eng("Version 1.45", "Release 1.45"));
	DrawStr(44, 33, fr_eng("Version 1.45", "Release 1.45"), 1);
	draw_str(fr_eng(21,24), 44, fr_eng("par Franois LEIBER", "by Francois LEIBER"));
	draw_line(fr_eng(22, 25), 53, fr_eng(134, 131), 53);
	contrast_moins(1000);
	ngetchx();
	contrast_plus(15000);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Affiche le menu apparaissant au dbut (moment = 0) ou accessible en cours de partie avec ECHAP (moment = 1)
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void menu(TABLEAU tableau, BYTE joueur_type[], int *nbre_ordi, int *joueur, int *nbre_blancs, int moment)
{
	static char *niveau[] = {fr_eng("HUMAIN", "HUMAN"), fr_eng("STUPIDE", "STUPID"), fr_eng("FAIBLE", "NOVICE"), fr_eng("MOYEN", "MEDIUM"), "CORRECT", fr_eng("BON", "GOOD"), "EXPERT", "PRO"};
	static int titre[] = {19,128,	65535,61439,60416,28669,32792,511,  65472,6240,		// Dessin du titre "Othello II"
									65535,61439,60416,28669,32792,511,  65472,6240, 
									49152,57407,60416,27649,32792,384,  448,  6240, 
									49152,24639,60416,27649,32792,384,  192,  6240, 
									49152,24632,3072, 27649,32792,384,  192,  6240, 
									49152,24632,3072, 27649,32792,384,  192,  6240, 
									49152,24632,3072, 27649,32792,384,  192,  6240, 
									49152,24632,3072, 60417,32792,384,  192,  6240, 
									49152,24632,4095, 61437,32792,384,  192,  6240, 
									49152,24632,4095, 61437,49180,384,  192,  7280, 
									49152,24632,3968, 61313,57374,384,  192,  7800, 
									49152,24632,3968, 28545,61471,384,  192,  8060, 
									49152,24632,3968, 28545,61471,384,  192,  8060, 
									49152,24632,3968, 28545,61471,384,  192,  8060, 
									49152,24632,3968, 28545,61471,384,  192,  8060, 
									49152,24632,3968, 28545,61471,384,  192,  8060, 
									49152,57400,3968, 28545,61471,384,  448,  8060, 
									65535,57400,3968, 28669,65503,65023,65472,8060, 
									65535,57392,3840, 28669,65503,65023,65472,7800		};
	char buf[18];
	int touche, i, j = 0, per = perdant;

	tourne_pion_y = 33;
	FontSetSys(NORMAL);

	GKeyFlush();
	GrayMode(GRAY_ON);					// Initialise les niveaux de gris et met en place l'interface du menu
	fill_rect(0, 0, 239, 127, 0);
	SetPlane(0);
	ScrRectFill(&(SCR_RECT){3, 3, 156, 96}, &(SCR_RECT){0, 0, 159, 99}, 1);
	BitmapPut(17, 7, &titre, &(SCR_RECT){0, 0, 159, 99}, 2);
	draw_rect(0, 0, 159, 99, 1);
	draw_rect(2, 2, 157, 97, 1);
	BitmapPut(16, 6, &titre, &(SCR_RECT){0, 0, 159, 99}, 1);
	BitmapPut(17, 7, &titre, &(SCR_RECT){0, 0, 159, 99}, 1);

	Debut:
	fill_rect(21, 30, 136, 90, 0);
	if (moment)
	{
		draw_str(35, 33, fr_eng("CONTINUER", "RESUME"));
		draw_str(35, 45, fr_eng("NOUVELLE PARTIE", "NEW GAME"));
	}
	else
	{
		draw_str(35, 33, fr_eng("NOUVELLE PARTIE", "NEW GAME"));
		if (tab_sav[0]) draw_str(35, 45, fr_eng("CHARGER PARTIE", "LOAD SAVED GAME"));	// Affiche cet lment en gris si aucune partie
		else DrawStr(35, 45, fr_eng("CHARGER PARTIE", "LOAD SAVED GAME"), 3);			// sauve n'est accessible
	}

	draw_str(35, 57, "OPTIONS");
	draw_str(35, 69, fr_eng("INFOS", "ABOUT"));
	draw_str(35, 81, fr_eng("QUITTER", "QUIT"));

	OSFreeTimer(2); OSVFreeTimer(2);				// Initialise le timer pour faire tourner les pion du menu
	OSVRegisterTimer(2, 3, tourne_pion);

	do
	{
		touche = ngetchx();
 		if ((touche == HAUT)||(touche == BAS))		// Dplacement dans le menu
		{
			j = (j+(touche == BAS)-(touche == HAUT)+5)%5;
			if ((j == 1)&&!tab_sav[0]&&!moment) j += (touche == BAS)-(touche == HAUT);
			tourne_pion_y = 33+12*j;
			fill_rect(23, 30, 32, 88, 0);
			fill_rect(127, 33, 134, 88, 0);
		}
	} while ((touche != ENTER)&&(touche != ESCAPE));

	OSVFreeTimer(2);

	if ((touche == ESCAPE)&&!moment||(j == 4))								// Quitter
	{
		longjmp(jmp_quit, 1);
	}
	contrast_plus(5000);
	if (touche != ESCAPE)
	{
		if (j == 2) { options(joueur_type, niveau); contrast_moins(15000); goto Debut; }			// Options
		if (j == 3) { about(); contrast_moins(15000); goto Debut; }									// Infos
		if (!j&&!moment||(j == 1)&&moment)									// Nouvelle partie -> idem Charger partie
		{																	// sauf que c'est au premier coup
			charger(4, tableau, joueur, nbre_blancs);
			per = perdant;
		}
		if ((j == 1)&&!moment) 												// Charger partie
		{
			charger(64, tableau, joueur, nbre_blancs);
		}
	}

	contrast_moins(9999);
	GrayMode(GRAY_OFF);
	*nbre_ordi = (joueur_type[0] > 0)+(joueur_type[1] > 0);
	if ((per != perdant)&&(moment)) for (i=0; i<=70; i++) coeff[i] *= -1;

	ClrScr();
	DrawClipRect(&(WIN_RECT){0, 0, 159, 99} , &(SCR_RECT){0, 0, 159, 99}, 1);	// Affichage du cadre du terrain
	DrawClipRect(&(WIN_RECT){2, 2, 157, 97} , &(SCR_RECT){0, 0, 159, 99}, 1);
	FontSetSys(GRAS);
	ScrRectFill (&(SCR_RECT){3, 3, 156, 12}, &(SCR_RECT){0, 0, 159, 99}, 1);
	DrawStr(5, 3, "OTHELLO II  v1.45", 2);
	DrawPix(2, 2, 0); DrawPix(157, 2, 0);
	DrawLine(2, 3, 3, 2, 0); DrawLine(157, 3, 156, 2,0);

	for (i=0; i<=8; i++) { DrawLine(4, 10*i+14, 84, 10*i+14, 1); DrawLine(10*i+4, 14, 10*i+4, 94, 1); }	// Dessine le plateau
	DrawLine(85, 15, 85, 95, 1);
	DrawLine(5, 95, 85, 95, 1);


	for (i=0; i<=70; i++) if (tableau[i] <= 1) draw_pion(i,tableau[i]);						// Remplit le plateau

	FontSetSys(PETIT);
	sprintf(buf, "%s vs %s", niveau[joueur_type[1]], niveau[joueur_type[0]]);				// buf contient le nom des protagonistes
	i = DrawStrWidth(buf, PETIT)/2;
	DrawStr(121-i, 20, buf, 1); DrawLine(122-i, 27, 120+i, 27, 1);
	FontSetSys(NORMAL);

	if ((*joueur != moment)&&!(moment&&(j == 1)&&(touche == ENTER))) DrawChar(90, 36, '', 1); else DrawChar(90, 50, '', 1);

	if ((j == 1)&&moment&&(touche == ENTER)) longjmp(jmp_debut, 1);		// Si le menu est appel pendant le jeu et que 'Continuer' a t choisi
	if (moment) longjmp(jmp_return, 1);				// Si moment est nul (menu appel en dbut de partie), jmp_return[] n'est pas encore dfini
}
